Tutorial Framework
==================

## Frontend dependencies

Open up a terminal in `src/app/static`. Issue `yarn install` to install dependencies and `webpack` to compile the
frontend source.

## Building and running with Docker

Simply issue `docker build .` in the root of the project. The first build could take a while as it's compiling a fresh
Python package from source. Subsequent builds can reuse this layer, so their execution time is significantly shorter.

Run with `docker run -p 4242:4242 <id>` to bind the container's port to localhost.

## Running locally

Create a new virtualenv, preferably with [virtualenvwrapper](https://virtualenvwrapper.readthedocs.io). Install the
dependencies with `pip install tornado pyzmq transitions`. If using virtualenvwrapper, issue `add2virtualenv lib` from
the project root to add the local libraries to the virtualenv's PYTHONPATH.

To start the project issue
```
cd src/app/
python app.py
```
in one terminal, and
```
cd src/components/
python event_handler_main.py
```
in another. Prepend the python commands with `PYTHONPATH="../../lib/"` if the folder weren't added to the PYTHONPATH
permanently.
